#include <tinyalsa/asoundlib.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv) {
    unsigned rate = (argc > 1) ? atoi(argv[1]) : 8000;
    struct pcm_config cfg = {
            .channels = 1,
            .rate     = rate,
            .format   = PCM_FORMAT_S16_LE,
            .period_size = 160,   // 20 ms @ 8 kHz
            .period_count = 4,
    };
    struct pcm *pcm = pcm_open(0, 0, PCM_IN, &cfg);   // card 0, device 0, CAPTURE
    if (!pcm || !pcm_is_ready(pcm)) return 1;

    unsigned char buf[320];  // 160 samples * 2 bytes
    while (1) {
        if (pcm_read(pcm, buf, sizeof(buf)) == 0)
            fwrite(buf, 1, sizeof(buf), stdout);      // stream to pipe
        else
            break;
    }
    pcm_close(pcm);
    return 0;
}
